local addonName, L = ...;
local BH = ByeHakmud

ByeHakmud_SavedVariables = false
local sv = ByeHakmud_SavedVariables

SavedVariablesPerCharacter = false
local svpc = SavedVariablesPerCharacter

BH.Vars = {}
BH.Vars.loaded = false;

function BH.Vars:SetSavedVariables(vars)
    SavedVariables = vars
    sv = vars
end

function BH.Vars:SetSavedVariablesPerCharacter(vars)
    SavedVariablesPerCharacter = vars
    svpc = vars
end

function BH.Vars:IsByeHakmudEnabled()
	local retVal = true;
	if sv.ByeHakmudEnabled ~= nil then
	    retVal = sv.ByeHakmudEnabled;
	end
	return retVal;
end

function BH.Vars:SetByeHakmudEnabled(enabled)
    sv.ByeHakmudEnabled = enabled;
    sv.IsDismountHakmudEnabled= nil
end

function BH.Vars:IsHakmudKeptOnShift()
	local retVal = true;
	if (sv.HakmudKeptOnShift ~= nil) then
		retVal = sv.HakmudKeptOnShift;
	end
	return retVal;
end

function BH.Vars:SetHakmudKeptOnShift(keep)
	sv.HakmudKeptOnShift = keep;
end

function BH.Vars:IsOnlyEjectWhenInParty()
    local retVal = false;
    if (sv.OnlyEjectWhenInParty ~= nil) then
	retVal = sv.OnlyEjectWhenInParty;
    end
    return retVal;
end

function BH.Vars:SetOnlyEjectWhenInParty(EjectInParty)
    sv.OnlyEjectWhenInParty = EjectInParty
end

function BH.Vars:GetChannelToNotify()
    local retVal = "local"
    if sv and sv.ChannelToNotify ~= nil then
	retVal = sv.ChannelToNotify
    end
    return retVal
end

function BH.Vars:SetChannelToNotify(channel)
    sv.ChannelToNotify = channel
end

function BH.Vars:GetNotifyMsg()
    local retVal = L["ByeHakmud ejected [passenger] from [mount]"];
    if sv and sv.NotifyMsg ~= nil then
	retVal = sv.NotifyMsg
    end
    return retVal
end

function BH.Vars:SetNotifyMsg(msg)
    sv.NotifyMsg = msg
end

function BH.Vars:GetVersion()
	local version = "unversioned";
	local repoDate = "$Date: 2012-10-22 10:15:58 +0000 (Mon, 22 Oct 2012) $";
	local repoUrl = "$URL: file:///media/cf-repositories/svn/wow/byehakmud/mainline/tags/V%202.00.02/ByeHakmudVars.lua $";

	repoUrl = string.gsub(repoUrl, "%%20", " "); -- spaces are url encoded
	local tagPattern = "/tags/[^/]*";
	local tagStart, tagEnd = string.find(repoUrl, tagPattern);

	if (tagStart ~= nil and tagEnd ~= nil) then
		tagStart = tagStart + string.len("/tags/");
		version = string.sub(repoUrl, tagStart, tagEnd);
	else
		local datePattern = "$Date:[^$]*";
		local dateStart, dateEnd = string.find(repoDate, datePattern);
		if (dateStart ~= nil and dateEnd ~= nil) then
			dateStart = dateStart + string.len("$Date:");
			dateStr = string.sub(repoDate, dateStart, dateEnd);
			version = "unversioned "..tostring(dateStr);
		end
	end
	
	return version;
end 

function BH.Vars:GetAddonUrl()
    return "http://www.curse.com/addons/wow/byehakmud"
end

function BH.Vars:GetPlayerPermissions()
    local retVal = nil
    if sv then
	if sv.PlayerPermissions == nil then
	    sv.PlayerPermissions = {}
	end
	retVal = sv.PlayerPermissions
    end
    return retVal
end

function BH.Vars:GetMountIDToSeat()
    local retVal = nil
    if sv then
	if sv.MountIDToSeat == nil then
	    sv.MountIDToSeat = {}
	end
	retVal = sv.MountIDToSeat
    end
    return retVal
end

function BH.Vars:IsLoaded()
    return BH.Vars.loaded
end

